"""
    Unison public API

    API for Python and R libraries  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from hyperunison_public_api_sdk.api_client import ApiClient, Endpoint as _Endpoint
from hyperunison_public_api_sdk.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from hyperunison_public_api_sdk.model.public_cohort_execute_query_request import PublicCohortExecuteQueryRequest
from hyperunison_public_api_sdk.model.response_to_ucdm_result_with_sql import ResponseToUCDMResultWithSql


class PublicAPIApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.public_cohort_execute_query_endpoint = _Endpoint(
            settings={
                'response_type': (ResponseToUCDMResultWithSql,),
                'auth': [],
                'endpoint_path': '/api/public/cohort/biobank/{biobankId}/execute-query',
                'operation_id': 'public_cohort_execute_query',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'api_key',
                    'biobank_id',
                    'public_cohort_execute_query_request',
                ],
                'required': [
                    'api_key',
                    'biobank_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'biobank_id',
                ]
            },
            root_map={
                'validations': {
                    ('biobank_id',): {

                        'regex': {
                            'pattern': r'\d+',  # noqa: E501
                        },
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'api_key':
                        (str,),
                    'biobank_id':
                        (str,),
                    'public_cohort_execute_query_request':
                        (PublicCohortExecuteQueryRequest,),
                },
                'attribute_map': {
                    'api_key': 'apiKey',
                    'biobank_id': 'biobankId',
                },
                'location_map': {
                    'api_key': 'header',
                    'biobank_id': 'path',
                    'public_cohort_execute_query_request': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )

    def public_cohort_execute_query(
        self,
        api_key,
        biobank_id,
        **kwargs
    ):
        """public_cohort_execute_query  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.public_cohort_execute_query(api_key, biobank_id, async_req=True)
        >>> result = thread.get()

        Args:
            api_key (str): Authorization by Api key
            biobank_id (str):

        Keyword Args:
            public_cohort_execute_query_request (PublicCohortExecuteQueryRequest): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            ResponseToUCDMResultWithSql
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['api_key'] = \
            api_key
        kwargs['biobank_id'] = \
            biobank_id
        return self.public_cohort_execute_query_endpoint.call_with_http_info(**kwargs)

